#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define MYSQL_HOST 	"mysql4.worldispnetwork.com"
#define MYSQL_USER 	"recnik"
#define MYSQL_PASS 	"kincer"
#define MYSQL_DB 	"recnik"

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <mysql.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

// gasimo aplikaciju brzo i prljavo...
// (quick'n'dirty)
void
on_zatvori_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
}

// pretrazi i napuni sqlite bazu...
void
on_click_pretrazi                      (GtkButton       *button,
                                        gpointer         user_data)
{

	GtkWidget * punos = lookup_widget(GTK_WIDGET(button), "unos");
	gchar * str = (gchar *) gtk_entry_get_text(GTK_ENTRY(punos));

  GtkWidget * lista = lookup_widget(GTK_WIDGET(button), "lista");

  GtkTreeStore *store = gtk_tree_store_new (BR_KOLONA,
                                          G_TYPE_STRING,
                                          G_TYPE_STRING);


  sqlite *db;
  char *zErrMsg = 0;
  int rc;

   int duzina = strlen(str);
   
   void * upit = calloc(duzina+48,sizeof(char));
   strcat((char *) upit,"select eng,srp from recnik where eng like '%");
   strcat((char *) upit,(char *) str);
   strcat((char *) upit,"%';");
  
  db = sqlite_open(PACKAGE_DB_DIR"/recnik.db", 0, &zErrMsg);
  if( db==0 ){
      
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом отварања датотекe са базом речника:\n%s\n\nПроверите да ли имати одговарајуће привилегије над датотеком "PACKAGE_DB_DIR"/recnik.db. Можете покушати да ажурирате базу речника."),
                                  zErrMsg);
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);
     // Zasto ovde nece da prekine program???
     g_free(db);gtk_main_quit();exit(1);
  }
  rc = sqlite_exec(db, upit, dodajrec_clb, (void*) store, &zErrMsg);
  if( rc!=SQLITE_OK ){
    
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом извршавања упита:\n%s\n\nПроверите да ли имати одговарајуће привилегије над датотеком "PACKAGE_DB_DIR"/recnik.db. Можете покушати да ажурирате базу речника."),
                                  zErrMsg);
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);
     gtk_main_quit();
  }
  sqlite_close(db);
  g_free (upit);
  


gtk_tree_view_set_model (GTK_TREE_VIEW(lista),GTK_TREE_MODEL (store));
g_object_unref (G_OBJECT (store));

gtk_entry_set_text((GtkEntry *)punos,"");

}


// kopiraj u clipboard prevod reci koja je selektovana
// u listi, koristi glavni GTK clipboard, ostavljajuci X-ov
// clipboard netaknut...
void
on_select_lista (GtkTreeSelection *selection, gpointer data)
{
        GtkTreeIter iter;
        GtkTreeModel *model;
        gchar *prevod;

        if (gtk_tree_selection_get_selected (selection, &model, &iter))
        {
		GtkClipboard * clip;
                gtk_tree_model_get (model, &iter, SRP, &prevod, -1);


		clip = gtk_clipboard_get ( gdk_atom_intern("CLIPBOARD",FALSE) );

		gtk_clipboard_set_text          (clip,
                                                 prevod,
                                                 -1);

                
        }
        
        g_free (prevod);
}

void
on_click_azuriraj 														(GtkButton       *button,
                                        gpointer         user_data)
{

  sqlite *db;
  char *zErrMsg = 0;
  int rc;
  GtkWidget * pstatus;
  GtkWidget * pprogres;  
  char * verzija;
  MYSQL mysql;
   MYSQL_RES *resultv;
   MYSQL_ROW row;
   char * newver;
    char * vernew;
   void * upit;
   MYSQL_RES *result;
   unsigned int br_redova;
                float prog;

  

  db = sqlite_open(PACKAGE_DB_DIR"/recnik.db", 0, &zErrMsg);
  if( db==0 ){
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом отварања датотекe са базом речника:\n%s\n\nПроверите да ли имати одговарајуће привилегије над датотеком "PACKAGE_DB_DIR"/recnik.db. Можете покушати да ажурирате базу речника."),
                                  zErrMsg);
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

    gtk_main_quit();
  }
  rc = sqlite_exec(db, "select verzija from verzija;", verzija_clb, (void*) button, &zErrMsg);
  if( rc!=SQLITE_OK ){
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом извршавања упита:\n%s\n\nПроверите да ли имати одговарајуће привилегије над датотеком "PACKAGE_DB_DIR"/recnik.db. Можете покушати да ажурирате базу речника."),
                                  zErrMsg);
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);
     
    gtk_main_quit();
  }
   sqlite_close(db);
    pstatus = lookup_widget(GTK_WIDGET(button), "status");
    pprogres = lookup_widget(GTK_WIDGET(button), "progressbar1");

    verzija = calloc(14,sizeof(char));
    verzija = memcpy(verzija,gtk_label_get_text((GtkLabel*) pstatus),strlen(gtk_label_get_text((GtkLabel*) pstatus)));
    
    gtk_label_set_text((GtkLabel*) pstatus,_("<span size=\"small\" color=\"#666666\">Проверио сам локалну верзију базе речника.</span>"));  
    gtk_label_set_use_markup ((GtkLabel*) pstatus,TRUE);
    gtk_progress_bar_update ((GtkProgressBar*) pprogres,0.05);
    
   mysql_init(&mysql);
   
   if ( !mysql_real_connect(&mysql,MYSQL_HOST,MYSQL_USER,MYSQL_PASS,MYSQL_DB,0,NULL,0) ) {
   
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом успостављања конекције са удаљеном базом података:\n%s\n\nПроверите да ли ваша интернет конекција функционише и да ли се можете повезати на адресу "MYSQL_HOST"."),
                                  mysql_error(&mysql));
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

    gtk_main_quit();
   }

   if ( mysql_query(&mysql, "select vreme from prevodi order by vreme desc limit 1") ){

    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом сазнавања верзије удаљеног речника:\n%s\n\nПроверите да ли ваша интернет конекција функционише и да ли се можете повезати на адресу "MYSQL_HOST"."),
                                  mysql_error(&mysql));
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

     
     gtk_main_quit();
   }
   
   
   resultv = mysql_use_result(&mysql);
   row = mysql_fetch_row(resultv);
   newver = row[0];
   
    vernew = calloc(14,sizeof(char));
    vernew = memcpy(vernew,newver,strlen(newver));

   mysql_free_result(resultv);

   upit = calloc(110,sizeof(char));
   strcat((char *) upit,"select e.izraz, p.prevod,0 from engleski e, prevodi p where e.id=p.engleski and p.vreme>");
   strcat((char *) upit,(char *) verzija);

   if ( mysql_query(&mysql, (char*) upit) ) {

    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом извршавања упита на удаљеној бази речника:\n%s\n\nПроверите да ли ваша интернет конекција функционише и да ли се можете повезати на адресу "MYSQL_HOST"."),
                                  mysql_error(&mysql));
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

     
     gtk_main_quit();
   }


   result = mysql_store_result(&mysql);
   
   
    if (result) {
        br_redova = mysql_num_rows(result);
        g_print("ukupno %i redova\n",br_redova);

        if (br_redova > 0) {
          float rec=0.80/br_redova;

              gtk_label_set_text((GtkLabel*) pstatus,_("<span size=\"small\" color=\"#666666\">Ажурирам спискове.<span>"));  
              gtk_label_set_use_markup ((GtkLabel*) pstatus,TRUE);
              gtk_progress_bar_update ((GtkProgressBar*) pprogres,0.1);
              

                
  db = sqlite_open(PACKAGE_DB_DIR"/recnik.db", 0, &zErrMsg);
  if( db==0 ){
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом отварања датотекe са базом речника:\n%s\n\nПроверите да ли имати одговарајуће привилегије над датотеком "PACKAGE_DB_DIR"/recnik.db. Можете покушати да ажурирате базу речника."),
                                  zErrMsg);
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

    gtk_main_quit();
  }
 
              gtk_label_set_text((GtkLabel*) pstatus,_("<span size=\"small\" color=\"#666666\">Ажурирам изразе.</span>"));  
              gtk_label_set_use_markup ((GtkLabel*) pstatus,TRUE);
              
		prog=0.1;
                while( (row = mysql_fetch_row(result)) ) {
                  int duzina1, duzina2;
		  void *upit1,*upit2;
                       prog=prog+rec;
                       gtk_progress_bar_update ((GtkProgressBar*) pprogres,prog);
                       
                       duzina2 = strlen(row[1]);
                       duzina1 = strlen(row[0]);
                       upit1 = calloc(duzina1+duzina2+45,sizeof(char));
                       strcat((char *) upit1,"delete from recnik where eng='");
                       strcat((char *) upit1,(char *) row[0]);
                       strcat((char *) upit1,"' and srp='");
                       strcat((char *) upit1,(char *) row[1]);
                       strcat((char *) upit1,"';");

                       sqlite_exec(db, upit1, NULL, NULL, &zErrMsg);
		       g_free(upit1); 
			  
		
                       if(atoi(row[2])==0) {
			
                       upit2 = calloc(duzina1+duzina2+45,sizeof(char));
                       strcat((char *) upit2,"insert into recnik(srp,eng) VALUES('");
                       strcat((char *) upit2,(char *) row[1]);	
                       strcat((char *) upit2,"','");
                       strcat((char *) upit2,(char *) row[0]);	
                       strcat((char *) upit2,"');");
                       
                       sqlite_exec(db, upit2, NULL, NULL, &zErrMsg);
                       g_free(upit2);
                       }

              
                }
                {
                       void * upit3;
		       upit3 = calloc(80,sizeof(char));
                       strcat((char *) upit3,"update verzija set verzija='");
                       strcat((char *) upit3,(char *) vernew);	
                       strcat((char *) upit3,"' where verzija='");
                       strcat((char *) upit3,(char *) verzija);
                       strcat((char *) upit3,"';");	
                       
                       sqlite_exec(db, upit3, NULL, NULL, &zErrMsg);
                       g_free(upit3);
		}
                                      
   sqlite_close(db);
                           
        }   
        else {
              
 		          
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_CLOSE,
                                  _("Речник је већ ажуриран на најновију верзију."));
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);
     
        } 
    }
    else  {
        if (mysql_errno(&mysql)) {
           
    GtkMessageDialog * dialog;
    dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  _("Дошло је до грешке приликом извршавања упита на удаљеној бази речника:\n%s\n\nПроверите да ли ваша интернет конекција функционише и да ли се можете повезати на адресу "MYSQL_HOST"."),
                                  mysql_error(&mysql));
     gtk_dialog_run (GTK_DIALOG (dialog));
     gtk_widget_destroy ((GtkWidget*) dialog);

     
     gtk_main_quit();
     
	}
    }
    

    gtk_progress_bar_update ((GtkProgressBar*) pprogres,1);
              
    mysql_free_result(result);
    mysql_close(&mysql);
    g_free(verzija);
    g_free(vernew);
    g_free(upit);
    

   


}

// callback za sqlite...
int dodajrec_clb(void * store, int c, char **v, char **azColName) {
  int i;

    GtkTreeIter   iter;

  for(i=0; i<c; i=i+2){

    gtk_tree_store_append (store, &iter, NULL);
    gtk_tree_store_set (store, &iter,
                    ENG, v[i],
                    SRP, v[i+1],
                    -1);
  }


  return 0;
}

int verzija_clb(void * button, int c, char **v, char **azColName) {

    
    GtkWidget * pstatus = lookup_widget(GTK_WIDGET(button), "status");
    gtk_label_set_use_markup ((GtkLabel*) pstatus,FALSE);
    gtk_label_set_text((GtkLabel*) pstatus,(char*) v[0]);
    
  return 0;
}
